from .const import CONF_CALLBACK_URL_OVERRIDE as CONF_CALLBACK_URL_OVERRIDE, CONF_LISTEN_PORT as CONF_LISTEN_PORT, CONF_POLL_AVAILABILITY as CONF_POLL_AVAILABILITY, DOMAIN as DOMAIN
from .data import get_domain_data as get_domain_data
from collections.abc import Callable as Callable
from homeassistant import config_entries as config_entries
from homeassistant.components import ssdp as ssdp
from homeassistant.const import CONF_DEVICE_ID as CONF_DEVICE_ID, CONF_NAME as CONF_NAME, CONF_TYPE as CONF_TYPE, CONF_URL as CONF_URL
from homeassistant.core import callback as callback
from homeassistant.data_entry_flow import FlowResult as FlowResult
from homeassistant.exceptions import IntegrationError as IntegrationError
from homeassistant.helpers.typing import DiscoveryInfoType as DiscoveryInfoType
from typing import Any, Mapping, Optional

LOGGER: Any
FlowInput = Optional[Mapping[str, Any]]

class ConnectError(IntegrationError): ...

class DlnaDmrFlowHandler(config_entries.ConfigFlow):
    VERSION: int
    _discoveries: Any
    def __init__(self) -> None: ...
    @staticmethod
    def async_get_options_flow(config_entry: config_entries.ConfigEntry) -> config_entries.OptionsFlow: ...
    async def async_step_user(self, user_input: FlowInput = ...) -> FlowResult: ...
    async def async_step_import(self, import_data: FlowInput = ...) -> FlowResult: ...
    async def async_step_ssdp(self, discovery_info: DiscoveryInfoType) -> FlowResult: ...
    async def async_step_confirm(self, user_input: FlowInput = ...) -> FlowResult: ...
    async def _async_create_entry_from_discovery(self, discovery: Mapping[str, Any], options: Union[Mapping[str, Any], None] = ...) -> FlowResult: ...
    async def _async_get_discoveries(self) -> list[Mapping[str, str]]: ...
    async def _async_connect(self, location: str) -> dict[str, str]: ...

class DlnaDmrOptionsFlowHandler(config_entries.OptionsFlow):
    config_entry: Any
    def __init__(self, config_entry: config_entries.ConfigEntry) -> None: ...
    async def async_step_init(self, user_input: Union[dict[str, Any], None] = ...) -> FlowResult: ...
